<script lang="ts">
import { ref, onMounted, getCurrentInstance } from 'vue';
import {
  allowSelection,
  forbidSelection,
} from '@new-jira-clone/ui/src/composables/useSelectionControl';
import useKeydownEventOffsetStep from '@new-jira-clone/ui/src/composables/utils/useKeydownEventOffsetStep';

export default {
  name: 'JDraggable',
  props: {
    initialTop: {
      type: [Number, String],
      default: null,
    },
    initialRight: {
      type: [Number, String],
      default: null,
    },
    initialBottom: {
      type: [Number, String],
      default: null,
    },
    initialLeft: {
      type: [Number, String],
      default: null,
    },
  },
  setup(props) {
    const defaultSlot = ref<HTMLElement | null>(null);
    const slotRects = {
      top: 0,
      left: 0,
      width: 0,
      height: 0,
    };
    const startMousePosition = {
      x: 0,
      y: 0,
    };

    const { getOffsetStepOnKeyboardEvent, resetKeydownState } = useKeydownEventOffsetStep();
    
    const isntance = getCurrentInstance();
    
    const getPxOrInitialData = (initialData: number | string): string => {
      if (typeof initialData === 'number') {
        return `${initialData}px`;
      }

      return initialData;
    }

    onMounted(() => {
      if (!isntance?.subTree?.children?.length) return;

      if ((isntance.subTree.children.length as number) > 1) {
        console.warn('A JDraggable component require 1 child slots');
      } else {
        defaultSlot.value = isntance.subTree.children.at(0).el as HTMLElement;
      }

      if (defaultSlot.value && (props.initialTop || props.initialLeft)) {
        defaultSlot.value.style.position = 'absolute';

        if (props.initialTop) {
          defaultSlot.value.style.top = getPxOrInitialData(props.initialTop);
        }

        if (props.initialRight) {
          defaultSlot.value.style.top = getPxOrInitialData(props.initialRight);
        }

        if (props.initialBottom) {
          defaultSlot.value.style.top = getPxOrInitialData(props.initialBottom);
        }

        if (props.initialLeft) {
          defaultSlot.value.style.left = getPxOrInitialData(props.initialLeft);
        }
      }
    });

    const setPosition = async (
      block: HTMLElement,
      x: number | null,
      y: number | null,
    ): Promise<void> => {
      if (!block) return;

      block.style.position = 'absolute';

      if (x) {
        block.style.top = `${x}px`;
      }

      if (y) {
        block.style.left = `${y}px`;
      }
    };

    const onMouseMove = async (event: MouseEvent): Promise<void> => {
      if (defaultSlot.value === null) return;

      setPosition(
        defaultSlot.value,
        slotRects.top + event.clientY - startMousePosition.y,
        slotRects.left + event.clientX - startMousePosition.x
      );
    };

    const stopDrag = () => {
      allowSelection();
      document.removeEventListener('mouseup', stopDrag);
      document.removeEventListener('blur', stopDrag);
      document.removeEventListener('mousemove', onMouseMove);
    };

    const setEventListeners = (): void => {
      document.addEventListener('mouseup', stopDrag);
      document.addEventListener('blur', stopDrag);
      document.addEventListener('mousemove', onMouseMove);
    };

    const onMouseDown = async (event: MouseEvent): Promise<void> => {
      if (defaultSlot.value === null) return;

      const slotStyles = window.getComputedStyle(defaultSlot.value);

      slotRects.top = parseInt(slotStyles.top, 10);

      if (!slotRects.top) {
        slotRects.top = (defaultSlot.value.offsetTop -
          parseInt(slotStyles.marginTop, 10)) as number;
      }

      slotRects.left = parseInt(slotStyles.left, 10);

      if (!slotRects.left) {
        slotRects.left = defaultSlot.value.offsetLeft - parseInt(slotStyles.marginLeft, 10);
      }

      slotRects.width = parseInt(slotStyles.width, 10);
      slotRects.height = parseInt(slotStyles.height, 10);

      startMousePosition.x = event.clientX;
      startMousePosition.y = event.clientY;

      forbidSelection();
      setEventListeners();
    };

    const onKeydown = async (event: KeyboardEvent): Promise<void> => {
      if (!defaultSlot.value) return;

      // TODO: refactor getComputedStyle for optimization
      const slotStyles = window.getComputedStyle(defaultSlot.value);

      const [x, y] = getOffsetStepOnKeyboardEvent(event);

      setPosition(
        defaultSlot.value,
        parseInt(slotStyles.top, 10) + y,
        parseInt(slotStyles.left, 10) + x,
      );
    };

    return {
      onMouseDown,
      onKeydown,
      resetKeydownState,
    };
  },
};
</script>

<template>
  <slot
    @mousedown="onMouseDown"
    @keydown="onKeydown"
    @keyup="resetKeydownState"
  />
</template>
